import 'dart:async';

import 'package:flutter/material.dart';

class ReviewDialog {
  ReviewDialog();

  FutureOr<bool> satisfaction() => throw UnimplementedError();
  FutureOr<void> opinion() => throw UnimplementedError();
}

class DefaultReviewDialog implements ReviewDialog {
  final BuildContext context;
  final String satisfactionText;
  final Widget satisfactionLikeIcon;
  final String satisfactionLikeText;
  final Widget satisfactionDislikeIcon;
  final String satisfactionDislikeText;
  final String opinionText;
  final String opinionSubmitButtonText;
  final String opinionCancelButtonText;
  final String opinionAnonymousText;

  const DefaultReviewDialog({
    required this.context,
    required this.satisfactionText,
    required this.satisfactionLikeIcon,
    required this.satisfactionLikeText,
    required this.satisfactionDislikeIcon,
    required this.satisfactionDislikeText,
    required this.opinionText,
    required this.opinionSubmitButtonText,
    required this.opinionCancelButtonText,
    required this.opinionAnonymousText,
  });

  @override
  FutureOr<void> opinion() {
    // TODO: implement opinion
    throw UnimplementedError();
  }

  @override
  FutureOr<bool> satisfaction() async {
    final isSatisfied = await showDialog<bool>(
      context: context,
      builder: (ctx) => Dialog(
        child: Padding(
          padding: const EdgeInsets.all(12),
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              Text(
                satisfactionText,
                style: const TextStyle(fontSize: 13),
              ),
              const SizedBox(height: 20),
              Row(
                mainAxisSize: MainAxisSize.min,
                children: [
                  SizedBox(
                    width: 110,
                    child: ElevatedButton.icon(
                      onPressed: () {
                        Navigator.pop(ctx, true);
                      },
                      icon: const Icon(Icons.thumb_up),
                      label: Text(
                        satisfactionLikeText,
                        style: const TextStyle(fontSize: 12),
                      ),
                    ),
                  ),
                  const SizedBox(width: 20),
                  SizedBox(
                    width: 110,
                    child: ElevatedButton.icon(
                      onPressed: () {
                        Navigator.pop(ctx, false);
                      },
                      icon: const Icon(Icons.thumb_down),
                      label: Text(
                        satisfactionDislikeText,
                        style: const TextStyle(fontSize: 12),
                      ),
                      style: ElevatedButton.styleFrom(
                        backgroundColor: Colors.grey,
                      ),
                    ),
                  ),
                ],
              ),
            ],
          ),
        ),
      ),
    );

    return isSatisfied == true;
  }
}
